#!/usr/local/bin/ruby
#nDiary on the Web
# sessionˤѥǧ
# ȡեǥեȡԽإ
# եθȰԽإ
# ե뤬ɹʤжԽܥǽ
#  <̤>̵ƤȺ
# ץ
#  <̤>ʥץԶн
# ڡ
#  <̤>10ԤǺǿڡķ֡

require 'webframe'
require 'dummyout'
require 'sffile'
require 'find'
require 'kconv'
require 'tempfile'

class WebFrame < WebFrameSeed

  def initialize
    super
    
    @menu = ['input', 'list', 'upload', '|', 'update', '|', 'diary']
    @password         = PASSWORD
    @log_directory    = LOG_DIRECTORY
    @output_directory = OUTPUT_DIRECTORY
    @script_directory = SCRIPT_DIRECTORY
    @latest_filename  = LASTEST_FILENAME
    outdir = @output_directory
    outdir += '/' if @output_directory !~ /\/$/
    @diaryfile = outdir + @latest_filename
    @sffile = SFfile::new

    @txtarea_height = defined?(TXTAREA_HEIGHT) ? TXTAREA_HEIGHT : 30
    @txtarea_width  = defined?(TXTAREA_WIDTH)  ? TXTAREA_WIDTH  : 80
    
    @script_url = ENV['SCRIPT_URI'].to_s
    @script_url = 'http://' + ENV['REMOTE_HOST'].to_s + ENV['REQUEST_URI'].to_s if @script_url == '' #REMOTE_HOST = REMOTE_ADDR ?
    
#    cmd_select
#=begin
    begin
      cmd_select
    rescue #Exception
      @message = $!
      cmd_error
    end
#=end
  end

#========== jump ========== ========== ==========
  def cmd_select
    pass_check
    cmd_login if @pass != @password #ιԤ򥳥ȥȤǡѥǧʤʤޤ

    begin
      @cmd = @cgi['cmd'].first.read || 'index'
    rescue Exception
      @cmd = @cgi['cmd'].first || 'index'
    end

    case @cmd
    when 'index'
      cmd_index
    when 'list'
      cmd_list
    when 'input'
      cmd_input
    when 'upload'
      cmd_upload
    when 'edit'
      cmd_edit
    when 'save'
      cmd_save
    when 'update'
      cmd_update
    when 'exec'
      cmd_exec
    when 'diary'
      cmd_diary
    end
    
    cmd_index
  end

  def menu_index ( menu )
    menu_list = []
    menu.each{ |name|
#      if name == 'loginout'
#        name = (@name == @def_guestname) ? 'login' : 'logout'
#      end
      case name
      when 'index'
        menu_list << '<a href="' + @script_name + '">[index]</a>'
      when 'list'
        menu_list << '<a href="' + @script_name + '?cmd=list">[list]</a>'
      when 'input'
        menu_list << '<a href="' + @script_name + '?cmd=input">[input]</a>'
      when 'upload'
        menu_list << '<a href="' + @script_name + '?cmd=upload">[upload]</a>'
#      when 'edit'
#        menu_list << '<a href="' + @script_name + '?cmd=edit">[edit]</a>'
      when 'update'
        menu_list << '<a href="' + @script_name + '?cmd=update">[update]</a>'
      when 'save'
        menu_list << '<a href="' + @script_name + '?cmd=save">[save]</a>'
      when 'exec'
        menu_list << '<a href="' + @script_name + '?cmd=exec">[exec]</a>'
      when 'diary'
        menu_list << '<a href="' + @script_name + '?cmd=diary">[diary]</a>'
      when 'top'
        menu_list << '<a href="index.html">[top]</a>'
      else
        menu_list << name
      end
    }
    return menu_list
  end

#========== login ========== ========== ==========
  def cmd_login
    @title = 'onDiary; login'
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<form action="#{@script_name}" method="post">
password? :
<input type="text" size="8" name="pass">
<input type="submit" value="login">
</form>
</p>
<hr width="50%" align="left" />
<p>
ȤꤢѥɤϤƲ<br />
config.txtΤǤ<br />
</p>
    END
    html_page
  end

#========== index ========== ========== ==========
  def cmd_index
    cmd_input
  end

  def cmd_list
    list = []
    Find.find(@log_directory){ |file|
      if file =~ /\/(\d{8})(\.diary|\.dia)$/i
        list << [file, File.mtime(file), File.size(file)]
#        list << [file, 0, 0]
      end
    }
    liststr = [['file', 'time', 'size']]
    list.sort{ |x,y| x.first <=> y.first}.each{ |file, time, size|
      time = time.strftime("%c")
      file =~ /\/(\d{8})(\.diary|\.dia)$/i
      name, date = $1 + $2, File.basename(file, $2)
      liststr << ["<a href=\"#{@script_name}\?cmd=edit&file=#{file}\">#{date}<\/a>", time, size]
    }
    
    if @cgi.has_key?('download')
      @header = { "type" => "text/plain", "charset" => "euc-jp" }
      liststr.shift
      str = ''
      liststr.each{ |line| str << line.join("\t") + "\n" }
      @cgi.out(@header){ str }
      exit
    end
    
    dumstr =  ''
    str = @sffile.table_writer(dumstr, liststr, 50)
    
    @title = 'onDiary; list'
    menu = menu_replace(@menu, 'list', '[list]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
#{str}
</p>
<hr width="50%" align="left">
<p>
config.txtǻꤷեʲ鸫ĤƤ.diaryեΰǤ<br />
աʥեˤ򥯥åԽķӤޤ<br />
եɤϡֱå¸פ餤Ǥꤤޤ<br />
</p>
    END
    html_page
  end

  def cmd_input
    date = Time.now.strftime("%Y%m%d")
    logdir = @log_directory
    logdir += '/' if logdir !~ /\/$/
    
    @title = 'onDiary; input'
    menu = menu_replace(@menu, 'input', '[input]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<form action="#{@script_name}" method="post">
#{logdir}<input type="text" size="10" name="date" value="#{date}">.diary<br />
<input type="hidden" name="cmd" value="edit">
<input type="submit" value="edit">
</form>
</p>
<hr width="50%" align="left">
<p>
Խ.diaryեλǤ<br />
Ȥꤢ̾ƤޤeditܥԽķӤޤ<br />
̤դ.diaryեꤿԽʤ顢Ǥľeditܥ򲡤Ƥ<br />
ʥ顼åƤʤΤǡȾѤȤȤ̾ߥȤĤơ<br />
ˤԽʤ顢˥塼[list]ǰФޤ<br />
</p>
    END
    html_page
  end

  def cmd_upload
    date = Time.now.strftime("%Y%m%d")
    logdir = @log_directory
    logdir += '/' if logdir !~ /\/$/
    
    @title = 'onDiary; upload'
    menu = menu_replace(@menu, 'upload', '[upload]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<form action="#{@script_name}" method="post" enctype="multipart/form-data">
[from]: <input type="file" name="uploaded_file"><br />
[to  ]: #{logdir}<input type="text" size="10" name="date" value="#{date}">.diary<br />
<input type="hidden" name="cmd" value="edit">
<input type="submit" value="upload">
</form>
</p>
<hr width="50%" align="left">
<p>
åץɤեλȡ<br />
ΥоǤ¸ե̾.diaryեˤλǤ<br />
Ȥꤢ̾ƤޤuploadܥԽķӤޤ<br />
ʤǲsaveܥ¸Ƥ<br />
ʥ顼åƤʤΤǡȾѤȤȤ̾ߥȤĤơ<br />
</p>
    END
    html_page
  end

  def cmd_edit
    file = @cgi['file'].first.to_s.strip
    date = @cgi['date'].first.to_s.strip
    date = @cgi['date'].first.read if @cgi.has_key?('uploaded_file')
    logdir = @log_directory
    logdir += '/' if logdir !~ /\/$/
    if file == ''
      if date != ''
        file = logdir + date + '.diary'
      else
        file = logdir + Time.now.strftime("%Y%m%d") + '.diary'
      end
    end
    #ñ¡@log_directoryʲǤʤ硢̾Ǥʤ硢Ϥ
    ex_logdir = File.expand_path(@log_directory)
    ex_file   = File.expand_path(file)
    cmd_input if ex_file !~ /^#{ex_logdir}/
    cmd_input if file !~ /\/(\d{8})(\.diary|\.dia)$/i
    
    text = ''
    text = open(file).read if FileTest.exist?(file)
    text = @cgi['uploaded_file'].first.read if @cgi.has_key?('uploaded_file')
    
    if @cgi.has_key?('download')
      @header = { "type" => "text/plain", "charset" => "euc-jp" }
      @cgi.out(@header){ text }
      exit
    end
    if @cgi.has_key?('upload')
      diary_save(file, text)
      @header = { "type" => "text/plain", "charset" => "euc-jp" }
      @cgi.out(@header){ 'message: save ok.' }
      exit
    end
    
    @title = 'onDiary; edit'
#    menu = menu_replace(@menu, 'edit', '[edit]')
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
#{file}
</p>
<p>
<form action="#{@script_name}" method="post">
<input type="hidden" name="file" value="#{file}">
<textarea cols="#{@txtarea_width}" rows="#{@txtarea_height}" name="text">#{text}</textarea><br />
<input type="hidden" name="cmd" value="save">
<input type="submit" value="save">
<input type="checkbox" name="single">ȯ
</form>
</p>
<hr width="50%" align="left">
<p>
.diaryեԽƤ<br />
ԽƤե̾˽ФƤޤ<br />
saveܥ򲡤¸Ǥ<br />
ְȯפåȤȡ쵤ޤķӤޤ<br />
</p>
    END
    html_page
  end

  def cmd_save
    file = @cgi['file'].first.to_s.strip
    text = @cgi['text'].first.to_s.strip
    cmd_single if @cgi.has_key?('single')
    
    text = diary_save(file, text)
    
    @title = 'onDiary; save'
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
#{file}
</p>
<p>
<pre>
#{text}
</pre>
</p>
<p>
<a href="#{@script_name}?cmd=update">update</a>
</p>
<hr width="50%" align="left">
<p>
.diaryե¸ǧ<br />
ʾΥե̾Ƥ¸ޤ<br />
updateܥķӤޤ<br />
դ.diaryեԽΤǤ顢[input][list]ԽäƤ<br />
</p>
    END
    html_page
  end

  def cmd_update
    @title = 'onDiary; update'
    menu = menu_replace(@menu, 'update', '[update]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<form action="#{@script_name}" method="post">
ruby diary <input type="text" size="20" name="option"><br />
<input type="hidden" name="cmd" value="exec">
<input type="submit" value="exec">
</form>
</p>
<hr width="50%" align="left">
<p>
nDiaryμ¹ԡ<br />
nDiaryΥץɬפǤǤǤ<br />
ץ̵кǿȡǿդޤ<br/>
ץ󤬡200101פʤ2001ǯ1ΤϤǤ<br />
execܥnDiary¹Ԥޤ<br />
</p>
    END
    html_page
  end

  def cmd_exec
    option = @cgi['option'].first.to_s.strip
    
    message = diary_exec(option)
    
    @title = 'onDiary; save'
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<pre>
#{message}
</pre>
</p>
<p>
<a href="#{@diaryfile}">diary</a>
</p>
<hr width="50%" align="left">
<p>
nDiaryμ¹Գǧ<br />
ĤʤDOSήå򤳤˽ФƤޤ<br/>
diary󥯤ķӤޤ<br />
htmlκǿɽˤϡɤɬפ⤷ޤ<br />
</p>
    END
    html_page
  end

  def cmd_diary
    @title = 'onDiary; diary'
    menu = menu_replace(@menu, 'diary', '[diary]')
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<a href="#{@diaryfile}">diary</a>
</p>
<hr width="50%" align="left">
<p>
diary󥯤ķӤޤ<br />
htmlκǿɽˤϡɤɬפ⤷ޤ<br />
</p>
    END
    html_page
  end

  def cmd_single
    file = @cgi['file'].first.to_s.strip
    text = @cgi['text'].first.to_s.strip
    option = @cgi['option'].first.to_s.strip
    
    diary_save(file, text)
    message = diary_exec(option)
    
    @title = 'onDiary; single'
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<pre>
#{message}
</pre>
</p>
<p>
<a href="#{@diaryfile}">diary</a>
</p>
<hr width="50%" align="left">
<p>
nDiaryμ¹Գǧ<br />
ĤʤDOSήå򤳤˽ФƤޤ<br/>
diary󥯤ķӤޤ<br />
</p>
    END
    html_page
  end

#========== engine ========== ========== ==========
  def diary_save ( file, text )
    text.gsub!(//,"\t")
    open(file, 'w'){ |fp|
      fp.write(text)
    }
    return text
  end

  def diary_exec ( option )
    File.umask(0022) #html-fileѤѹ
    Dir.chdir(@script_directory)
    $KCODE = 'SJIS'
    file = 'message.txt'
#    fp = Tempfile.open(file)
    fp = DummyOut.new()
    $defout = $stdout = $stderr = fp
    argstr = 'diary'
    exefile = argstr 
    exefile = File.readlink(argstr) if FileTest.symlink?(argstr)
    dir = File.dirname(exefile)
    Dir.chdir(dir)
    $: << dir
    require 'ndiary-lib.rb'
    require 'ndiary-custom.rb'
    argv = option.split
    begin
      main(argv)
    rescue Exception
      fp.write $!
    end
    $defout, $stderr = STDOUT, STDERR
#    $stdout = STDOUT #Ի׵Ĥʻˤ򤹤ȡνϥ롼ǻߤޤ
#    fp.close
#    fp.open
#    message = fp.read
#    fp.close(true)
    message = fp.buffer
#    File.delete(file)
#    message = Kconv.toeuc($stdout.bufferout)
#    message.scan(/make '(.+)'/){ |file|
#      File.chmod(0644, file)
#    }
    $KCODE = 'EUC'
    File.umask(0066) #session-fileѤѹ
    return message
  end

#========== message ========== ========== ==========
  def cmd_error
    @title = '顼Զ礬ȯޤ'
    @message = '' if @message.nil?
    menu = @menu
    @head_html = head_html(menu)
    @body_html = <<-END
<p>
<h3>#{@title}</h3>
</p>
<p>
#{@message}
</p>
<p>
#{$!}
</p>
<p>
ҤΥåԶͳȽǤ礦<br />
б񤷤ϡ
<a href="http://ippo.s5.xrea.com"></a>
(<a href="mailto:ippo@geocities.co.jp">mail</a>,
<a href="http://146.teacup.com/ippo/bbs">BBS</a>)
˸Ϣꤤޤ<br />
</p>
    END
    html_page
  end

#===== html ===== =====
  def head_html( menu )
    menu_list = menu_index(menu)
    str = <<-END
<div align="right">
<iframe height="60" width="468" title="ad" frameborder="0" marginheight="0" marginwidth="0" scrolling="no" src="http://ad.xrea.com/ad_iframe.fcg?site=ippo.s5.xrea.com"><a href="http://ad.xrea.com/ad_click.fcg?site=ippo.x5.xrea.com" target="_blank"><img src="http://ad.xrea.com/ad_img.fcg?site=ippo.x5.xrea.com" height="60" width="468" border="0" alt="ad"></a></iframe>
</div>
<table bgcolor="##{@titlecolor}" width="100%">
<tr>
<td align="left">
#{menu_list.join("\n")}
</td>
</tr>
</table>
    END
    return str
  end

  def tail_html
    @tail_html = <<-END
<table bgcolor="##{@titlecolor}" width="100%"><tr><td align="right">
<a href="http://ippo.s5.xrea.com"></a>
(<a href="mailto:ippo@geocities.co.jp">mail</a>,
<a href="http://146.teacup.com/ippo/bbs">BBS</a>) |
<a href="http://www.ruby-lang.org/ja/">Ruby</a> /
<a href="http://www14.cds.ne.jp/~not/product/ndiary/">nDiary</a> /
<a href="http://www.xrea.com/">XREA</a> |
<a href="index.html">[up]</a> /
<a href="http://ippo.s5.xrea.com">[top]</a>
</td></tr></table>
    END
    return @tail_html
  end
end

WebFrame.new
